//#define _GLIB_CXX_DEBUG_
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

std::vector<std::vector<int>> g;
std::vector<int> paint;
int cmp = 0;
std::vector<std::vector<int>> comps;
bool flag;

void dfs(int v) {
    for (auto u : g[v]) {
        if (paint[u] == paint[v])
            flag = false;
        if (paint[u] == 0) {
            paint[u] = ((paint[v] == 1) ? 2 : 1);
            comps[cmp].push_back(u);
            dfs(u);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    //std::iostream::sync_with_stdio(false);
    //std::cin.tie(0), std::cout.tie(0);
    int n, m;
    std::cin >> n >> m;
    g.resize(n);
    paint.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        std::cin >> v >> u;
        g[v - 1].push_back(u - 1);
        g[u - 1].push_back(v - 1);
    }
    for (int i = 0; i < n; i++) {
        if (paint[i] == 0) {
            comps.push_back({});
            flag = true;
            paint[i] = 1;
            comps[cmp].push_back(i);
            dfs(i);
            if (!flag) {
                comps.pop_back();
            } else {
                cmp++;
            }
        }
    }
    int sum = 0;
    for (int i = 0; i < cmp; i++)
        sum += comps[i].size();
    if (sum != n)
        std::cout << -1;
    else {
        std::cout << cmp << '\n';
        for (int i = 0; i < cmp; i++) {
            std::cout << comps[i][0] + 1 << ' ';
        }
    }
    return 0;
}
